Subject: Re: Proposed Text for RFC2445 Issue #15: Recurrence Rules

From: Damon Chaplin <[email-masked]>
Date: Thu, 30 Nov 2000 23:28:03 +0000

Eric Busboom wrote:

> Not all date BYxxx rule parts can appear simultaneously in a single
> recurrence rule. Date BYxxx rule part restrictions are:
> 
>         [a] If the BYYEARDAY part appears in a rule , no other date rule
>         part may appear.
> 
>         [b] BYWEEKNO and BYMONTH rule parts may not both appear.
>         [ except when week covers two months?]
> 
> Furthermore, not all date rule parts may be used with all recurrence
> intervals.
> 
>         [c] For MONTHLY recurrences (FREQ=MONTHLY) neither BYYEARDAY nor
>         BYWEEKNO may appear.
> 
>         [d] For WEEKLY recurrences (FREQ=WEEKLY) neither BYMONTHDAY nor
>         BYYEARDAY may appear.
> 
> There are no restrictions regarding combinations of date rule parts and
> time rule parts. There are no restrictions with using any combination of
> time rule parts
> 
> [ The BYYEARDAY part, for a given year, effectively specifies the month,
> day of month, and week number, so restriction [a] eliminates ambiguity
> between the day of year and other specifiers.
> 
> Restrictions [b] is similar, since the week number specifies the month for
> a given year. There may be a probably with this restriction when the week
> overlaps two months, though.
> 
> ]

I'm happy with these restrictions.
Though since I've seen some weird RRULEs used to calculate particular dates,
I'm slightly worried that these could have been useful in that sort of situation. 

Also it still doesn't cover one ambiguity I mentioned a while back:

o The BYDAY modifier is ambiguous. In a YEARLY frequency with BYMONTH or
  BYWEEKNO set, does the BYDAY modifier apply to the year day or the
  month/week day?

I'd guess it applies to the month or week day. Maybe this was meant to
be inferred from the order of application of the rule parts, so maybe the
text just needs clarifying.

Damon